/* Board */
#include "board.h"
#include "clock_config.h"
#include "peripherals.h"
#include "pin_mux.h"

/* Debug Console */
#include "fsl_debug_console.h"

/* FreeRTOS */
#include "FreeRTOS.h"
#include "task.h"

static void initialization_task(void *params);

int main(void) {
    BOARD_InitBootPins();
    BOARD_BootClockFROHF96M();
    BOARD_InitBootPeripherals();

    BOARD_InitDebugConsole();

    PRINTF("Hello world!!\r\n");

    if (xTaskCreate(initialization_task, "INIT", 2048, NULL, 2, NULL) != pdPASS) {
        PRINTF("Failed to create initialization task...\r\n");

        goto dead_loop;
    }

    vTaskStartScheduler();

dead_loop:
    /* We should never reach here. */
    for (;;) {
        __WFI();
    }
}

static void initialization_task(void *params) {
    PRINTF("Initialization task running...\r\n");

    /* Do initialization stuff here, since the scheduler is running now. */

    vTaskDelete(NULL);
}